package Übungen.TicTac;
import javax.swing.*;
import java.awt.*;

public class SpielfeldGUI {
	
	private JFrame frame;
    private JButton[][] buttons;

    public SpielfeldGUI() {
        frame = new JFrame("Spielfeld");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(300, 300);

        // Erstelle ein 3x3 GridLayout
        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(3, 3));

        // Erstelle das Spielfeld mit 3x3 Buttons
        buttons = new JButton[3][3];

        
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                buttons[i][j] = new JButton("-");
                buttons[i][j].addActionListener(e -> {
                    JButton clickedButton = (JButton) e.getSource();
                    clickedButton.setText("X");  // Ändert den Text zu "X" beim Klick
                });
                panel.add(buttons[i][j]);
            }
        }

        // Füge das Panel zum Frame hinzu
        frame.add(panel);
        frame.setVisible(true);  // Zeige das Fenster an
    }

    public static void main(String[] args) {
        // Starte die GUI
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                new SpielfeldGUI();
            }
        });
    }
}
