package GUIAnwendungen;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextField;


public class TextEingaben extends JFrame implements ActionListener {
    // Instanzvariablen
    private JTextField textField;
    private JButton button1;

    // Konstruktor
    public TextEingaben() {
        // Initialisiere das Textfeld und den Button
        textField = new JTextField();
        textField.setPreferredSize(new Dimension(240, 40));

        button1 = new JButton("Submit");
        button1.setPreferredSize(new Dimension(240, 40));
        button1.addActionListener(this); // `this` verweist auf das aktuelle Objekt der Klasse

        // Setze das Layout und füge die Komponenten hinzu
        setLayout(new FlowLayout());
        add(textField);
        add(button1);

        // Konfiguriere das JFrame
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(500, 500);
        setVisible(true);
    }

    // Die Methode wird aufgerufen, wenn der Button gedrückt wird
    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == button1) {
            System.out.println("Hallo " + textField.getText());
        }
    }

    public static void main(String[] args) {
        // Erstelle eine Instanz der Klasse, wodurch der Konstruktor aufgerufen wird
        new TextEingaben();
    }
}

