package oop.InnereKlassen;

public class Allgemein {
	
	/*Was ist das?
	 * - In Java gibt es vier Haupttypen von inneren Klassen (auch bekannt als Nested Classes)
	 * - Diese Klassen werden innerhalb einer anderen Klasse definiert und haben unterschiedliche Eigenschaften und Anwendungsfälle
	 * - es ist die Möglichkeit eine Klasse in eine andere Klasse zu binden
	 * - diese Klasse heißt "innere Klasse"
	 * - Java definiert vier Typen von inneren Klassen
	 * 
	 * 
	 * . Zusammenfassung: 
	 *	 - Statische Innere Klassen:  sind unabhängig von der äußeren Klasseninstanz und haben Zugriff nur auf die statischen Mitglieder der äußeren Klasse.
	 *	 - Nicht-statische Innere Klassen:  benötigen eine Instanz der äußeren Klasse und haben Zugriff auf alle Mitglieder dieser Instanz.
	 *	 - Lokale Innere Klassen: sind methoden-spezifisch und können nur innerhalb der Methode verwendet werden, in der sie definiert sind.
	 *	 - Anonyme Innere Klassen:  sind namenlose Klassen, die sofort erstellt werden und in der Regel verwendet werden, um eine Schnittstelle oder abstrakte Klasse schnell zu implementieren.
	 */
	class Außen{
		class Innen{
			
		}
	}

}
